Index: data/trunk/materials/JumpBoots.material
===================================================================
--- data/trunk/materials/JumpBoots.material	(revision 10079)
+++ data/trunk/materials/JumpBoots.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpBoots
+{
+	technique
+	{
+		pass JumpBoots
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpBoots.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpEnemy1.material
===================================================================
--- data/trunk/materials/JumpEnemy1.material	(revision 10079)
+++ data/trunk/materials/JumpEnemy1.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpEnemy1
+{
+	technique
+	{
+		pass JumpEnemy1
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpEnemy1.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpEnemy2.material
===================================================================
--- data/trunk/materials/JumpEnemy2.material	(revision 10079)
+++ data/trunk/materials/JumpEnemy2.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpEnemy2
+{
+	technique
+	{
+		pass JumpEnemy2
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpEnemy2.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpEnemy2Wing.material
===================================================================
--- data/trunk/materials/JumpEnemy2Wing.material	(revision 10079)
+++ data/trunk/materials/JumpEnemy2Wing.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpEnemy2Wing
+{
+	technique
+	{
+		pass JumpEnemy2Wing
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpEnemy2Wing.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpEnemy3.material
===================================================================
--- data/trunk/materials/JumpEnemy3.material	(revision 10079)
+++ data/trunk/materials/JumpEnemy3.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpEnemy3
+{
+	technique
+	{
+		pass JumpEnemy3
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpEnemy3.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpEnemy4.material
===================================================================
--- data/trunk/materials/JumpEnemy4.material	(revision 10079)
+++ data/trunk/materials/JumpEnemy4.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpEnemy4
+{
+	technique
+	{
+		pass JumpEnemy4
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpEnemy4.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpFigure.material
===================================================================
--- data/trunk/materials/JumpFigure.material	(revision 10079)
+++ data/trunk/materials/JumpFigure.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpFigure
+{
+	technique
+	{
+		pass JumpFigure
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpFigure.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpFigureLeftHand.material
===================================================================
--- data/trunk/materials/JumpFigureLeftHand.material	(revision 10079)
+++ data/trunk/materials/JumpFigureLeftHand.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpFigureLeftHand
+{
+	technique
+	{
+		pass JumpFigureLeftHand
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpFigureLeftHand.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpFigureRightHand.material
===================================================================
--- data/trunk/materials/JumpFigureRightHand.material	(revision 10079)
+++ data/trunk/materials/JumpFigureRightHand.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpFigureRightHand
+{
+	technique
+	{
+		pass JumpFigureRightHand
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpFigureRightHand.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPlatform01.material
===================================================================
--- data/trunk/materials/JumpPlatform01.material	(revision 10079)
+++ data/trunk/materials/JumpPlatform01.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPlatform01
+{
+	technique
+	{
+		pass JumpPlatform01
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPlatform01.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPlatform02.material
===================================================================
--- data/trunk/materials/JumpPlatform02.material	(revision 10079)
+++ data/trunk/materials/JumpPlatform02.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPlatform02
+{
+	technique
+	{
+		pass JumpPlatform02
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPlatform02.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPlatform03.material
===================================================================
--- data/trunk/materials/JumpPlatform03.material	(revision 10079)
+++ data/trunk/materials/JumpPlatform03.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPlatform03
+{
+	technique
+	{
+		pass JumpPlatform03
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPlatform03.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPlatform04.material
===================================================================
--- data/trunk/materials/JumpPlatform04.material	(revision 10079)
+++ data/trunk/materials/JumpPlatform04.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPlatform04
+{
+	technique
+	{
+		pass JumpPlatform04
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPlatform04.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPlatform05.material
===================================================================
--- data/trunk/materials/JumpPlatform05.material	(revision 10079)
+++ data/trunk/materials/JumpPlatform05.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPlatform05
+{
+	technique
+	{
+		pass JumpPlatform05
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPlatform05.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPlatform06.material
===================================================================
--- data/trunk/materials/JumpPlatform06.material	(revision 10079)
+++ data/trunk/materials/JumpPlatform06.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPlatform06
+{
+	technique
+	{
+		pass JumpPlatform06
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPlatform06.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpProjectile.material
===================================================================
--- data/trunk/materials/JumpProjectile.material	(revision 10079)
+++ data/trunk/materials/JumpProjectile.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpProjectile
+{
+	technique
+	{
+		pass JumpProjectile
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpProjectile.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpPropeller.material
===================================================================
--- data/trunk/materials/JumpPropeller.material	(revision 10079)
+++ data/trunk/materials/JumpPropeller.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpPropeller
+{
+	technique
+	{
+		pass JumpPropeller
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpPropeller.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpRocket.material
===================================================================
--- data/trunk/materials/JumpRocket.material	(revision 10079)
+++ data/trunk/materials/JumpRocket.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpRocket
+{
+	technique
+	{
+		pass JumpRocket
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpRocket.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpShield.material
===================================================================
--- data/trunk/materials/JumpShield.material	(revision 10079)
+++ data/trunk/materials/JumpShield.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpShield
+{
+	technique
+	{
+		pass JumpShield
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpShield.png
+			}
+		}
+
+	}
+
+}
Index: data/trunk/materials/JumpSpring.material
===================================================================
--- data/trunk/materials/JumpSpring.material	(revision 10079)
+++ data/trunk/materials/JumpSpring.material	(revision 10079)
@@ -0,0 +1,20 @@
+
+material JumpSpring
+{
+	technique
+	{
+		pass JumpSpring
+		{
+			ambient 0.8 0.8 0.8 1
+			diffuse 0.64 0.64 0.64 1
+			specular 0.5 0.5 0.5 1 12.5
+
+			texture_unit
+			{
+				texture JumpSpring.png
+			}
+		}
+
+	}
+
+}