Index: /branches/playability/src/world_entities/effects/trail.cc
===================================================================
--- /branches/playability/src/world_entities/effects/trail.cc	(revision 10082)
+++ /branches/playability/src/world_entities/effects/trail.cc	(revision 10083)
@@ -163,5 +163,5 @@
   Vector now, later;
   float fact  = 1.0/this->sections;
-  float rad0, rad1;
+  float radzero, radone;
 
   //glPushAttrib(GL_ENABLE_BIT);
@@ -231,6 +231,6 @@
   for( int i = 1; i < this->sections-1; i++)
   {
-    rad1  = this->radius * (1.0-i*fact);
-    rad0  = this->radius * (1.0-(i+1)*fact);
+    radone  = this->radius * (1.0-i*fact);
+    radzero  = this->radius * (1.0-(i+1)*fact);
 
     now   =  this->nodeList[i];
@@ -242,6 +242,6 @@
 
     // horizontal polygon
-    Q[0]  = now + Vector(0,rad1,0) ;
-    Q[3]  = now + Vector(0,-rad1,0) ;
+    Q[0]  = now + Vector(0,radone,0) ;
+    Q[3]  = now + Vector(0,-radone,0) ;
     
     glTexCoord2f(0.0f, 0.0f); glVertex3f(Q[0].x,Q[0].y,Q[0].z);
@@ -251,6 +251,6 @@
     {
       
-      Q[1]  = later + Vector(0,rad0,0) ;
-      Q[2]  = later + Vector(0,-rad0,0) ;
+      Q[1]  = later + Vector(0,radzero,0) ;
+      Q[2]  = later + Vector(0,-radzero,0) ;
       glTexCoord2f(0.0f, 1.0f); glVertex3f(Q[1].x,Q[1].y,Q[1].z);
       glTexCoord2f(1.0f, 1.0f); glVertex3f(Q[2].x,Q[2].y,Q[2].z);
@@ -263,6 +263,6 @@
   for( int i = this->sections-1; i > 0; i--)
   {
-    rad1  = this->radius * (1.0-i*fact);
-    rad0  = this->radius * (1.0-(i-1)*fact);
+    radone  = this->radius * (1.0-i*fact);
+    radzero  = this->radius * (1.0-(i-1)*fact);
 
     now   =  this->nodeList[i];
@@ -274,6 +274,6 @@
 
     // horizontal polygon
-    Q[0]  = now + Vector(0,rad1,0) ;
-    Q[3]  = now + Vector(0,-rad1,0) ;
+    Q[0]  = now + Vector(0,radone,0) ;
+    Q[3]  = now + Vector(0,-radone,0) ;
 
 	glTexCoord2f(1.0f, 0.0f); glVertex3f(Q[3].x,Q[3].y,Q[3].z);
@@ -282,6 +282,6 @@
     if( i == 1)
     {
-        Q[1]  = later + Vector(0,rad0,0) ;
-        Q[2]  = later + Vector(0,-rad0,0) ;
+        Q[1]  = later + Vector(0,radzero,0) ;
+        Q[2]  = later + Vector(0,-radzero,0) ;
 		glTexCoord2f(1.0f, 1.0f); glVertex3f(Q[2].x,Q[2].y,Q[2].z);
 		glTexCoord2f(0.0f, 1.0f); glVertex3f(Q[1].x,Q[1].y,Q[1].z);
@@ -295,6 +295,6 @@
   for( int i = 1; i < this->sections-1; i++)
   {
-    rad1  = this->radius * (1.0-i*fact);
-    rad0  = this->radius * (1.0-(i+1)*fact);
+    radone  = this->radius * (1.0-i*fact);
+    radzero  = this->radius * (1.0-(i+1)*fact);
 
     now   =  this->nodeList[i];
@@ -306,6 +306,6 @@
 
     // horizontal polygon
-    Q[0]  = now + targ.cross(Vector(0,rad1,0)) ;
-    Q[3]  = now + targ.cross(Vector(0,-rad1,0)) ;
+    Q[0]  = now + targ.cross(Vector(0,radone,0)) ;
+    Q[3]  = now + targ.cross(Vector(0,-radone,0)) ;
     
 	glTexCoord2f(0.0f, 0.0f); glVertex3f(Q[0].x,Q[0].y,Q[0].z);
@@ -314,6 +314,6 @@
     if( i == this->sections-1)
     {
-      Q[1]  = later + targ.cross(Vector(0,rad0,0)) ;
-      Q[2]  = later + targ.cross(Vector(0,-rad0,0)) ;
+      Q[1]  = later + targ.cross(Vector(0,radzero,0)) ;
+      Q[2]  = later + targ.cross(Vector(0,-radzero,0)) ;
       glTexCoord2f(0.0f, 1.0f); glVertex3f(Q[1].x,Q[1].y,Q[1].z);
       glTexCoord2f(1.0f, 1.0f); glVertex3f(Q[2].x,Q[2].y,Q[2].z);
@@ -326,6 +326,6 @@
   for( int i = this->sections-1; i > 0; i--)
   {
-    rad1  = this->radius * (1.0-i*fact);
-    rad0  = this->radius * (1.0-(i-1)*fact);
+    radone  = this->radius * (1.0-i*fact);
+    radzero  = this->radius * (1.0-(i-1)*fact);
 
     now   =  this->nodeList[i];
@@ -337,6 +337,6 @@
 
     // horizontal polygon
-    Q[0]  = now + targ.cross(Vector(0,rad1,0)) ;
-    Q[3]  = now + targ.cross(Vector(0,-rad1,0)) ;
+    Q[0]  = now + targ.cross(Vector(0,radone,0)) ;
+    Q[3]  = now + targ.cross(Vector(0,-radone,0)) ;
 
 	glTexCoord2f(0.0f, 0.0f); glVertex3f(Q[0].x,Q[0].y,Q[0].z);
@@ -345,6 +345,6 @@
     if( i == 1)
     {
-        Q[1]  = later + targ.cross(Vector(0,rad0,0)) ;
-        Q[2]  = later + targ.cross(Vector(0,-rad0,0)) ;
+        Q[1]  = later + targ.cross(Vector(0,radzero,0)) ;
+        Q[2]  = later + targ.cross(Vector(0,-radzero,0)) ;
 		glTexCoord2f(0.0f, 1.0f); glVertex3f(Q[1].x,Q[1].y,Q[1].z);
 		glTexCoord2f(1.0f, 1.0f); glVertex3f(Q[2].x,Q[2].y,Q[2].z);