Index: code/branches/towerdefenseHS14/src/modules/towerdefense/CMakeLists.txt
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/CMakeLists.txt	(revision 10086)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/CMakeLists.txt	(revision 10091)
@@ -5,5 +5,5 @@
   TowerDefenseHUDController.cc
   TowerDefensePlayerStats.cc
-
+  TowerTurret.cc
 )
 
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/Tower.cc
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/Tower.cc	(revision 10086)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/Tower.cc	(revision 10091)
@@ -46,5 +46,5 @@
     {
         static int yaw;
-        orxout() << "rotateYaw " << ++yaw << endl;
+        //orxout() << "rotateYaw " << ++yaw << endl;
     }
 
@@ -52,5 +52,5 @@
     {
         static int pitch;
-        orxout() << "rotatePitch " << ++pitch << endl;
+        //orxout() << "rotatePitch " << ++pitch << endl;
     }
 
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefense.cc
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefense.cc	(revision 10086)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefense.cc	(revision 10091)
@@ -75,5 +75,6 @@
 
 #include "TowerDefense.h"
-#include "Tower.h"
+//#include "Tower.h"
+#include "TowerTurret.h"
 #include "TowerDefenseCenterpoint.h"
 
@@ -190,5 +191,5 @@
 
         // Create tower
-        Tower* newTower = new Tower(this->center_->getContext());
+        TowerTurret* newTower = new TowerTurret(this->center_->getContext());
         newTower->addTemplate(this->center_->getTowerTemplate());
 
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefense.h
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefense.h	(revision 10086)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefense.h	(revision 10091)
@@ -92,5 +92,5 @@
 
         std::vector<Coordinate> addedTowersCoordinates_;
-        std::vector<Tower*> towers_;
+        std::vector<TowerTurret*> towers_;
     };
 }
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefenseController.cc
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefenseController.cc	(revision 10086)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefenseController.cc	(revision 10091)
@@ -53,4 +53,5 @@
         XMLPortParam(TowerDefenseController, "alertnessradius", setAlertnessRadius, getAlertnessRadius, xmlelement, mode).defaultValues(500.0f);
     }
+
 
     void TowerDefenseController::tick(float dt)
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefensePrereqs.h
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefensePrereqs.h	(revision 10086)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/TowerDefensePrereqs.h	(revision 10091)
@@ -66,8 +66,9 @@
 {
     class TowerDefense;
-    class Tower;
+    //class Tower;
     class TowerDefenseCenterpoint;
     class TowerDefenseHUDController;
     class TowerDefensePlayerStats;
+    class TowerTurret;
 }
 
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/TowerTurret.cc
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/TowerTurret.cc	(revision 10091)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/TowerTurret.cc	(revision 10091)
@@ -0,0 +1,41 @@
+//
+//  Tower.cc
+//  Orxonox
+//
+//  Created by Fabian Mentzer on 29.04.12.
+//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
+//
+
+/* Not implemented fully */
+
+//#include "Tower.h"
+#include "TowerTurret.h"
+
+#include "core/CoreIncludes.h"
+//#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(TowerTurret);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    TowerTurret::TowerTurret(Context* context) : StaticEntity(context)
+    {
+        RegisterObject(TowerTurret);
+
+        this->setCollisionType(WorldEntity::Static);
+
+
+    }
+
+    void TowerTurret::setOrientation(const Quaternion& orientation)
+    {
+        static int ori;
+        orxout() << "orientation " << ++ori << endl;
+    }
+
+
+}
Index: code/branches/towerdefenseHS14/src/modules/towerdefense/TowerTurret.h
===================================================================
--- code/branches/towerdefenseHS14/src/modules/towerdefense/TowerTurret.h	(revision 10091)
+++ code/branches/towerdefenseHS14/src/modules/towerdefense/TowerTurret.h	(revision 10091)
@@ -0,0 +1,53 @@
+//
+//  Tower.h
+//  Orxonox
+//
+//  Created by Fabian Mentzer on 29.04.12.
+//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
+//
+
+/**
+@brief
+See TowerDefenseReadme.txt for Information.
+
+@ingroup TowerDefense
+*/
+
+
+#ifndef Orxonox_Tower_h
+#define Orxonox_Tower_h
+
+#include "towerdefense/TowerDefensePrereqs.h"
+#include "worldentities/pawns/SpaceShip.h"
+#include "worldentities/StaticEntity.h"
+
+
+namespace orxonox
+{
+    class _TowerDefenseExport TowerTurret : public StaticEntity
+    {
+    public:
+        TowerTurret(Context* context);
+        virtual ~TowerTurret() {};
+
+        // Maybe later override these to move towers with cursor keys
+        /*
+        virtual void moveFrontBack(const Vector2& value);
+        virtual void moveRightLeft(const Vector2& value);
+        */
+
+        // Overriding these to stop towers from spasing out
+        void setOrientation(const Quaternion& orientation);
+        //virtual void rotateYaw(const Vector2& value);
+        //virtual void rotatePitch(const Vector2& value);
+        //virtual void rotateRoll(const Vector2& value);
+
+        void setGame(TowerDefense* towerdefense)
+        { assert(towerdefense); game_ = towerdefense; }
+    private:
+        TowerDefense* game_;
+    };
+}
+
+
+#endif