Index: /code/branches/minigame4DHS14/data/levels/4Dtest.oxw
===================================================================
--- /code/branches/minigame4DHS14/data/levels/4Dtest.oxw	(revision 10100)
+++ /code/branches/minigame4DHS14/data/levels/4Dtest.oxw	(revision 10101)
@@ -23,5 +23,5 @@
 
 <Level
- gametype = "Mini4Dgame"
+ gametype=Mini4Dgame
 >
 
@@ -49,12 +49,12 @@
 	<Mini4DgameCenterpoint name=mini4Dgamecenter width=16 height=16 length=16 position="0,0,0">
         <attached>
-            <Model position="1,1,1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="-1,1,1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="1,-1,1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="-1,-1,1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="1,1,-1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="-1,1,-1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="1,-1,-1" mesh="cube.mesh" scale3D="1,1,1" />
-            <Model position="-1,-1,-1" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="10,10,10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="-10,10,10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="10,-10,10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="-10,-10,10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="10,10,-10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="-10,10,-10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="10,-10,-10" mesh="cube.mesh" scale3D="1,1,1" />
+            <Model position="-10,-10,-10" mesh="cube.mesh" scale3D="1,1,1" />
         </attached>
     </Mini4DgameCenterpoint>
Index: /code/branches/minigame4DHS14/src/modules/CMakeLists.txt
===================================================================
--- /code/branches/minigame4DHS14/src/modules/CMakeLists.txt	(revision 10100)
+++ /code/branches/minigame4DHS14/src/modules/CMakeLists.txt	(revision 10101)
@@ -40,2 +40,3 @@
 ADD_SUBDIRECTORY(towerdefense)
 ADD_SUBDIRECTORY(invader)
+ADD_SUBDIRECTORY(mini4Dgame)
Index: /code/branches/minigame4DHS14/src/modules/mini4Dgame/CMakeLists.txt
===================================================================
--- /code/branches/minigame4DHS14/src/modules/mini4Dgame/CMakeLists.txt	(revision 10100)
+++ /code/branches/minigame4DHS14/src/modules/mini4Dgame/CMakeLists.txt	(revision 10101)
@@ -1,7 +1,5 @@
 SET_SOURCE_FILES(Mini4Dgame_SRC_FILES
-BUILD_UNIT mini4DgameBuildUnit.cc
   Mini4Dgame.cc
   Mini4DgameCenterpoint.cc
-END_BUILD_UNIT
 )
 
Index: /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4Dgame.cc
===================================================================
--- /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4Dgame.cc	(revision 10100)
+++ /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4Dgame.cc	(revision 10101)
@@ -41,6 +41,8 @@
 
 #include "core/CoreIncludes.h"
+#include "core/EventIncludes.h"
 #include "core/command/Executor.h"
 #include "core/config/ConfigValueIncludes.h"
+#include "infos/PlayerInfo.h"
 
 #include "gamestates/GSLevel.h"
@@ -62,5 +64,5 @@
         RegisterObject(Mini4Dgame);
 
-        this->center_ = NULL;
+        this->center_ = 0;
         //TODO: player Null setzen
     }
@@ -177,5 +179,5 @@
     PlayerInfo* Mini4Dgame::getPlayer(int color) const
     {
-        return players[color];
+        return players[color].info_;
     	//for(int i=0;i<NUMBEROFPLAYERS;i++)
         	//if(color == this->mini4DgamePlayers[i].color)
Index: /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4Dgame.h
===================================================================
--- /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4Dgame.h	(revision 10100)
+++ /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4Dgame.h	(revision 10101)
@@ -36,4 +36,5 @@
 
 #include "gametypes/Deathmatch.h"
+#include "mini4Dgame/Mini4DgamePrereqs.h"
 
 namespace orxonox
@@ -45,5 +46,5 @@
 
     */
-    class Mini4Dgame : public Deathmatch
+    class _Mini4DgameExport Mini4Dgame : public Deathmatch
     {
         public:
@@ -72,5 +73,5 @@
             void cleanup(void); //!< Cleans up the Gametype by destroying the ball and the bats.
 
-          PlayerInfo* players[3];
+          Player players[3];
 
             WeakPtr<Mini4DgameCenterpoint> center_; //!< The playing field.
Index: /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4DgameCenterpoint.h
===================================================================
--- /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4DgameCenterpoint.h	(revision 10100)
+++ /code/branches/minigame4DHS14/src/modules/mini4Dgame/Mini4DgameCenterpoint.h	(revision 10101)
@@ -40,4 +40,5 @@
 
 #include "worldentities/StaticEntity.h"
+#include "mini4Dgame/Mini4DgamePrereqs.h"
 
 namespace orxonox
@@ -57,5 +58,5 @@
         - The <b>batlength</b> is the length of the @ref orxonox::PongBat "PongBats" as the percentage of the height of the playing field. The default is <em>0.25</em>.
     */
-    class Mini4DgameCenterpoint : public StaticEntity
+    class _Mini4DgameExport Mini4DgameCenterpoint : public StaticEntity
     {
         public: