Index: code/branches/leveljoemeHS14/data/levels/AnihilationThreat.oxw
===================================================================
--- code/branches/leveljoemeHS14/data/levels/AnihilationThreat.oxw	(revision 10094)
+++ code/branches/leveljoemeHS14/data/levels/AnihilationThreat.oxw	(revision 10103)
@@ -22,4 +22,6 @@
   include("templates/spaceshipAssff.oxt")
   include("templates/spaceshipAssff2.oxt")
+  include("templates/spaceshipTransporter.oxt")
+
 ?>
 
@@ -31,4 +33,15 @@
   <?lua include("includes/notifications.oxi") ?>
   
+  <NotificationQueueCEGUI
+    name="narrative"
+    targets="simpleNotification"
+    size=8
+    displayTime=4
+    position="0.2, 0, 0.1, 0"
+    fontSize="23"
+    fontColor="0.8, 0.5, 0.2, 0.8"
+    alignment="HorzCentred"
+    displaySize="0.6, 0, 0, 0"
+    />
 
 <?lua
@@ -57,8 +70,8 @@
   	
   <SpawnPoint 
-	team=0 position="500,0,0" 
-	lookat="1,1,0" 
+	team=0 position="0,0,0" 
+	lookat="1,0,0" 
 	spawnclass=SpaceShip 
-	pawndesign=spaceshipswallow />
+	pawndesign=spaceshipassff />
 	
 	
@@ -70,72 +83,272 @@
         </PortalEndPoint>
     </Template>
-
-    <PortalEndPoint position="0,0,0" id="1" distance="40" target="MobileEntity" design="PortalDefault" reenterDelay="0"/>
-    <PortalEndPoint position="-1000,0,0" id="2" distance="40" target="MobileEntity" design="PortalDefault" reenterDelay="0"/>
-    <PortalLink fromID="1" toID="2" />
-    <PortalLink fromID="2" toID="1" />
-	
-	<DistanceTrigger name="switchPlanets" position="-1100,0,0" target="Pawn" distance=70 stayActive="true" delay=1/>
-
-<!-- switchBillboards makes this billboard INVISIBLE -->
-<Planet
-      position="-100000,0,0"
-      scale="10000"
-      collisionType="dynamic"
-      linearDamping="0.8"
-      angularDamping="0"
-      mass="5.9e21"
-      pitch="0"
-      mesh="planets/earth.mesh"
-      atmosphere="atmosphere1"
-      rotationaxis="0,1,0"
-      rotationrate="0.2"
-      atmospheresize="80.0f"
-      imagesize="1024.0f"
-      collisiondamage = 2
-      enablecollisiondamage = true
-    >
-   <events>
-      <visibility>
-        <EventTrigger invert=true>
-          <events>
-           <trigger>
-             <EventListener event=switchPlanets />
-           </trigger>
-         </events>
-        </EventTrigger>
-      </visibility>
-   </events>
-</Planet>
-	
-	
-	 <!-- This is a model of Earth: mass=EarthMass/1000 and radius=EarthRadius[km]*10 -->
-    <Planet
-      position="-100000,0,0"
-      scale="10000"
-      collisionType="dynamic"
-      linearDamping="0.8"
-      angularDamping="0"
-      mass="5.9e21"
-      pitch="0"
-      mesh="planets/earth.mesh"
-      atmosphere="atmosphere1"
-      rotationaxis="0,1,0"
-      rotationrate="0.2"
-      atmospheresize="80.0f"
-      imagesize="1024.0f"
-      collisiondamage = 2
-      enablecollisiondamage = true
-    >
-      <attached>
-        <ForceField position="0,0,0" mode="newtonianGravity" diameter="140000" massDiameter="126000" mass="5.9e21" />
-      </attached>
-      <collisionShapes>
-        <SphereCollisionShape radius="63000" position="0,0,0" />
-      </collisionShapes>
-    </Planet>
-    
-	
-	
+    
+    				
+    
+    		<!----------------Objects------------------>
+    
+    
+  
+    
+    
+    <!--Billboard which tirggers the next Quest and spawns the enemy ships-->
+     <Billboard position=" 5000,3000, 3500" material="Examples/Flare" colour="1.0, 0.0, 0.0" />    
+    
+<!-- Meteoriten, die sich bewegen -->
+   <?lua
+      for i = 1, 300, 1
+      do
+      j = math.random()
+      x = math.random()
+      y = math.random()
+      z = math.random()
+   ?>
+
+   <MovableEntity    
+      position = "<?lua print(math.random()* 600-300) ?>,<?lua print(math.random() * 40000 + 110000) ?>,<?lua print(math.random() * 600-300) ?>"
+      scale = "<?lua print(j * 40)?>"
+      velocity = "<?lua print(x*20-10)?>, <?lua print(y*60-160)?>, <?lua print(z*20-10)?>"
+      collisionType = dynamic
+      collisiondamage = 0.5
+      enablecollisiondamage = true 
+      active = true
+      visible = true
+   >                 
+          <attached>           
+              <Model mass="<?lua print(j * 1000) ?>" mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" >
+                  
+              </Model>                          
+          </attached> 
+         <collisionShapes>
+             <SphereCollisionShape radius="<?lua print(j * 50) ?>" />
+         </collisionShapes>   
+   </MovableEntity>
+
+   <?lua
+      end
+   ?>
+      <!-- Fiese Meteoriten, die direkt auf den Spieler zufliegen-->
+
+         <?lua
+            for i = 1, 240, 1
+            do
+            j = math.random()
+            x = math.random()
+            y = math.random()
+            z = math.random()
+         ?>
+         <MovableEntity    
+            position = "<?lua print(math.random()* 240-120) ?>,<?lua print(math.random() * 40000 + 110000) ?>,<?lua print(math.random()* 240-120) ?>"
+            scale = "10"
+            velocity = "0, -160, 0"
+            collisionType = dynamic
+            collisiondamage = 0.05
+            enablecollisiondamage = true 
+            active = true
+            visible = true
+         >                     
+                <attached>           
+                    <Model mass="2000" mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" >
+                      
+                    </Model>                    
+                </attached> 
+               <collisionShapes>
+                   <SphereCollisionShape radius="10" />
+               </collisionShapes>   
+         </MovableEntity>
+         <?lua
+            end
+         ?>
+
+
+    
+    
+    	    <!--******************************-Mission starts here****************************-->
+    			
+    			
+    			 <!------------On-screen texts---------->
+    
+<DistanceTrigger name="flying2" position="0,0,0" target="Pawn" distance=40 stayActive="true" delay=7/>
+    <SimpleNotification message="take the nearest portal">
+        <events>
+            <trigger>
+                <EventListener event="flying2" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+    
+    
+<DistanceTrigger name="flying2" position="0,0,0" target="Pawn" distance=100 stayActive="true" delay=7/>
+    <SimpleNotification message="In order to reach our fleet,">
+        <events>
+            <trigger>
+                <EventListener event="flying2" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+    
+    <DistanceTrigger name="flying1" position="0,0,0" target="Pawn" distance=100 stayActive="true" delay=1/>
+    <SimpleNotification message="Welcome Mr. Walker">
+        <events>
+            <trigger>
+                <EventListener event="flying1" />
+            </trigger>
+        </events>
+    </SimpleNotification>        
+        
+        <!--****************************After the Asteroid Field***************************-->
+        
+        <DistanceTrigger name="afterPortal" position="3000,3000,3000" target="Pawn" distance=100 stayActive="true" delay=1/>
+    <SimpleNotification message="Reach the red chekpoint">
+        <events>
+            <trigger>
+                <EventListener event="afterPortal" />
+            </trigger>
+        </events>
+    </SimpleNotification>
+    
+    
+<!--Creating player's team OK-->
+        <!--Spaceships team 0 (player:team=0)-->
+        
+        <SpaceShip position="3500,3000,3000" lookat="2050,0,-1000" name="allied" health="500" maxhealth="500" initialhealth="500" >
+             <templates>
+                  <Template link=spaceshipassff />
+            </templates>
+             <controller>
+                <WaypointPatrolController alertnessradius=2000 team=0 >
+                    <waypoints>
+                        <Model mesh="cube.mesh" scale=0 position="2050,0,-1000" />
+                        <Model mesh="cube.mesh" scale=0 position="6050,0,0" />
+                        <Model mesh="cube.mesh" scale=0 position="10050,0,3000" />
+                        <Model mesh="cube.mesh" scale=0 position="3050,0,3000" />
+                        <Model mesh="cube.mesh" scale=0 position="-4050,0,3000" />
+                    </waypoints>
+                </WaypointPatrolController>
+             </controller>
+        </SpaceShip>
+        <!--Second Spaceship team 0 (player: team 0)-->
+        <SpaceShip position="3500,3000,3600" lookat="2000,0,-950" name="allied" health="500" maxhealth="400" initialhealth="400" >
+             <templates>
+                  <Template link=spaceshipassff />
+            </templates>
+             <controller>
+                <WaypointPatrolController alertnessradius=2000 team=0 >
+                    <waypoints>
+                        <Model mesh="cube.mesh" scale=0 position="2000,0,-900" />
+                        <Model mesh="cube.mesh" scale=0 position="6000,0,0" />
+                        <Model mesh="cube.mesh" scale=0 position="10000,0,3100" />
+                        <Model mesh="cube.mesh" scale=0 position="3000,0,3100" />
+                        <Model mesh="cube.mesh" scale=0 position="-4000,0,3100"/>
+                    </waypoints>
+                </WaypointPatrolController>
+             </controller>
+        </SpaceShip>
+        <!--third Spaceship team 0 (player: team 0)-->
+        <SpaceShip position="3500,3000,34000" lookat="2000,0,-1050" name="allied" health="500" maxhealth="400" initialhealth="400" >
+             <templates>
+                  <Template link=spaceshipassff />
+            </templates>
+             <controller>
+                <WaypointPatrolController alertnessradius=2000 team=0 >
+                    <waypoints>
+                        <Model mesh="cube.mesh" scale=0 position="2000,0,-1100" />
+                        <Model mesh="cube.mesh" scale=0 position="6000,0,-100" />
+                        <Model mesh="cube.mesh" scale=0 position="10000,0,2900" />
+                        <Model mesh="cube.mesh" scale=0 position="3000,0,2900" />
+                        <Model mesh="cube.mesh" scale=0 position="-4000,0,2900" />
+                    </waypoints>
+                </WaypointPatrolController>
+             </controller>
+        </SpaceShip>
+<!--Creating player's team END  -->
+
+        
+
+
+		 <!------------Quest---------->
+
+
+ <QuestEffectBeacon times=1>
+            <effects>
+                <AddQuest questId="quest0" />
+                   <AddQuestHint hintId ="quest1hint2" />
+                <AddQuestHint hintId ="quest1hint3" />
+            </effects>
+            <events>
+                <execute>
+                    <EventListener event=spawntrigger />
+                </execute>
+            </events>
+        </QuestEffectBeacon>
+    
+    
+
+<Script code="showGUI NotificationLayer false true" needsGraphics="true" />
+
+<GlobalQuest id="quest0">
+		<QuestDescription title="Mission" description="Humanity is at war! Recently, an ashrocian ship attacked two transporters carrying highly expensive ETHium. Despite the fact, that the Ashrocs are a technological superpower, we, the human race cannot allow them to treat us like insects. Your mission's to group up with yout fellow soldiers and retaliate even harder." />
+	<hints>
+                <QuestHint id="quest1hint0">
+                    <QuestDescription title="The super Hint." description="Be proud of yourself." />
+                </QuestHint>
+    </hints>             
+</GlobalQuest>
+		
+		
+		
+	<DistanceTrigger name=QuestTrigger0 position="0,0,0" distance=10 target="Pawn" />
+
+
+
+ <QuestEffectBeacon times=1>
+            <effects>
+                <AddQuest questId="quest0" />
+                   <AddQuestHint hintId ="quest1hint2" />
+                <AddQuestHint hintId ="quest1hint3" />
+            </effects>
+            <events>
+                <execute>
+                    <EventListener event=QuestTrigger0 />
+                </execute>
+            </events>
+        </QuestEffectBeacon>
+    
+
+
+
+
+
+<?lua for i=0,0,1 do
+x=800
+health=1100
+?>
+    <!--Transporter 1-->
+    <EventTrigger name="activateTeam1No1" acitvations=1 stayactive="true">
+    <events>
+    <trigger>
+        <SpaceShip position="<?lua print(5000-i*x) ?>,3000,3000" lookat="<?lua print(4800-i*x) ?>,0,4000" health="<?lua print(health) ?>" maxhealth="<?lua print(health) ?>" initialhealth="<?lua print(health) ?>" >
+            <templates>
+                   <Template link=spaceshipTransporter />
+             </templates>
+			  <controller>
+                <WaypointPatrolController alertnessradius=2000 team=1 >
+                    <waypoints>
+                        <Model mesh="cube.mesh" scale=0 position="2000,0,-1100" />
+                        <Model mesh="cube.mesh" scale=0 position="6000,0,-100" />
+                        <Model mesh="cube.mesh" scale=0 position="10000,0,2900" />
+                        <Model mesh="cube.mesh" scale=0 position="3000,0,2900" />
+                        <Model mesh="cube.mesh" scale=0 position="-4000,0,2900" />
+                    </waypoints>
+                </WaypointPatrolController>
+             </controller>
+        </SpaceShip><!---->
+    </trigger>
+    </events>
+    </EventTrigger>
+<?lua end ?>
+
+    
+    
 	
     